<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE properties SYSTEM "http://java.sun.com/dtd/properties.dtd">
<properties>
    <entry key="listCurrentSQL">
        <![CDATA[
            select 
                l.storage_id,
                l.name,
                l.version,
                l.mime_type,
                l.editable,
                l.description,
                l.created_by,
                l.create_date,
                (select case when ? then l.content else null end) as content,
                l.content_size
            from libraries l, 
                (   select l.storage_id, l.name, max(l.create_date) as create_date
                    from libraries l
                    where 
                        l.storage_id = ?
                    and (? is null or l.name = ?)
                    and (? is null or l.mime_type = ?)
                    group by storage_id, name ) s
            where 
                l.storage_id = s.storage_id
            and l.name = s.name
            and l.create_date = s.create_date
        ]]>
    </entry>
    <entry key="listAllSQL">
        <![CDATA[
            select 
                l.storage_id,
                l.name,
                l.version,
                l.mime_type,
                l.editable,
                l.description,
                l.created_by,
                l.create_date,
                (select case when ? then l.content else null end) as content,
                l.content_size
            from libraries l
            where 
                l.storage_id = ?
            and (? is null or l.name = ?)
            and (? is null or l.mime_type = ?)
            order by l.storage_id, l.name, l.version, l.create_date asc
        ]]>
    </entry>
    <entry key="exactGetSQL">
        <![CDATA[
            select
                l.storage_id,
                l.name,
                l.version,
                l.mime_type,
                l.editable,
                l.description,
                l.created_by,
                l.create_date,
                (select case when ? then l.content else null end) as content,
                l.content_size
            from libraries l
            where 
                l.storage_id = ?
            and l.name = ?
            and l.version = ?
        ]]>
    </entry>
    <entry key="latestGetSQL">
        <![CDATA[
            select
                l.storage_id,
                l.name,
                l.version,
                l.mime_type,
                l.editable,
                l.description,
                l.created_by,
                l.create_date,
                (select case when ? then l.content else null end) as content,
                l.content_size
            from libraries l, 
                (   select l.storage_id, l.name, max(l.create_date) as create_date
                    from libraries l
                    where 
                        l.storage_id = ?
                    and l.name = ?
                    group by storage_id, name ) s
            where 
                l.storage_id = s.storage_id
            and l.name = s.name
            and l.create_date = s.create_date
        ]]>
    </entry>
    <entry key="saveSQL">
        <![CDATA[
            insert into libraries as l(storage_id, name, version, mime_type, editable, description, created_by, content, content_size)
            values(?, ?, ?, ?, ?, ?, ?, ?, ?)
            on conflict on constraint pk_libraries_storage_id_revision 
            do update
            set 
                description = excluded.description,
                content = excluded.content,
                content_size = excluded.content_size
            where 
                (l.editable or ?)
            returning 1
        ]]>
    </entry>
    <entry key="removeSQL">
        <![CDATA[
            delete from libraries where storage_id = ? and name = ? and (? is null or version = ?)
        ]]>
    </entry>
</properties>